package com.steerinfo.pretrack.prebeltscale.controller;

import com.steerinfo.baseinfo.meterbasecustomersupplier.service.IMeterBaseCustomerSupplierService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkbelttiminginfo.model.MeterWorkBeltTiminginfo;
import com.steerinfo.pretrack.prebeltscale.model.PreBeltScale;
import com.steerinfo.pretrack.prebeltscale.service.IPreBeltScaleService;
import com.steerinfo.util.CommonPage;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * PreBeltScale RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-22 07:48
 * 类描述
 * 修订历史：
 * 日期：2021-10-22
 * 作者：generator
 * 参考：
 * 描述：PreBeltScale RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/prebeltscales")
public class PreBeltScaleController extends BaseRESTfulController {

    @Autowired
    IPreBeltScaleService preBeltScaleService;


    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("prebeltscale:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<PreBeltScale> list = preBeltScaleService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("prebeltscale:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<PreBeltScale> list = preBeltScaleService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据PreBeltScale对象创建")
    @ApiImplicitParam(name = "preBeltScale", value = "详细实体preBeltScale", required = true, dataType = "PreBeltScale")
    //@RequiresPermissions("prebeltscale:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute PreBeltScale model){
        PreBeltScale preBeltScale = preBeltScaleService.add(model);
        return success(preBeltScale);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("prebeltscale:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        PreBeltScale preBeltScale = preBeltScaleService.getById(id);
        return success(preBeltScale);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的preBeltScale信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "preBeltScale", value = "详细实体preBeltScale", required = true, dataType = "PreBeltScale")
    })
    //@RequiresPermissions("prebeltscale:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody PreBeltScale model){
        model.setId(id);
        PreBeltScale preBeltScale = preBeltScaleService.modify(model);
        return success(preBeltScale);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("prebeltscale:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  preBeltScaleService.delete(ids);
    	}
      return success();
    }


    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据PreBeltScale对象创建")
    @ApiImplicitParam(name = "PreBeltScale", value = "详细实体PreBeltScale", required = true, dataType = "PreBeltScale")
    //@RequiresPermissions("PreBeltScale:create")
    @PostMapping(value = "/doAddBeltScalePrediction")
    public RESTfulResult doAddBeltScalePrediction(@RequestBody PreBeltScale model) {
        RESTfulResult rm = failed();
        try {
            int str =  preBeltScaleService.doAddBeltScalePrediction(model);
            if (str>0) {
                return success(str);
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "C#端皮带秤", notes = "根据PreBeltScale对象创建")
    @ApiImplicitParam(name = "PreBeltScale", value = "详细实体PreBeltScale", required = true, dataType = "PreBeltScale")
    //@RequiresPermissions("PreBeltScale:create")
    @PostMapping(value = "/doQueryLikeInfo")
    public RESTfulResult doQueryLikeInfo(@RequestBody CommonPage<PreBeltScale> model) {
        try {
            List<PreBeltScale> no = preBeltScaleService.doQueryLikeInfo(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }


    @ApiOperation(value = "C#端皮带秤", notes = "根据PreBeltScale对象创建")
    @ApiImplicitParam(name = "PreBeltScale", value = "详细实体PreBeltScale", required = true, dataType = "PreBeltScale")
    @PostMapping(value = "/doQueryWflike")
    public RESTfulResult doQueryWflike(@RequestBody CommonPage<PreBeltScale> model) {
        try {
            List<PreBeltScale> no = preBeltScaleService.doQuerylike(model);
            return success(no);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @Transactional(rollbackFor = Exception.class)
    @ApiOperation(value = "C#端皮带秤", notes = "根据PreBeltScale对象创建")
    @ApiImplicitParam(name = "PreBeltScale", value = "详细实体PreBeltScale", required = true, dataType = "PreBeltScale")
    //@RequiresPermissions("PreBeltScale:create")
    @PostMapping(value = "/doUpdateWf")
    public RESTfulResult doUpdateWf(@RequestBody PreBeltScale model) {
        RESTfulResult rm = failed();
        try {
            int str =  preBeltScaleService.updateScalePrediction(model);
            if (str>0) {
                return success(str);
            } else {
                return failed("操作失败!" + str);
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
            rm.setData(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！"+e.getMessage());
            rm.setData("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "C#端皮带秤", notes = "根据PreBeltScale对象创建")
    @ApiImplicitParam(name = "PreBeltScale", value = "详细实体PreBeltScale", required = true, dataType = "PreBeltScale")
    @PostMapping(value = "/doUpdateFlags")
    public RESTfulResult doUpdateFlags(@RequestBody List<PreBeltScale> models) {
        RESTfulResult rm = failed();
        int num= 0;
        try {
            if("0".equals(models.get(0).getValueFlag())){
                num = preBeltScaleService.doUpdateFlags_0(models);
            }else if("1".equals(models.get(0).getValueFlag())){
                num = preBeltScaleService.doUpdateFlags_1(models);
            }
            if(num>=1){
                return success(num);
            }else{
                return failed("修改预报状态失败");
            }
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

}
